-------------------------------------------------------------------------------
--                L  O  C  A  L     V  A  R  I  A  B  L  E  S
-------------------------------------------------------------------------------

local addonName, L = ...;

local raceName = {};
local raceKeystoneId = {};
local raceFragment = {};

local artifactId =
{
  [L["Ancient Amber"]]                         = 69776,
  [L["Ancient Shark Jaws"]]                    = 64355,
  [L["Anklet with Golden Bells"]]              = 64440,
  [L["Arrival of the Naaru"]]                  = 64456,
  [L["Atal'ai Scepter"]]                       = 64348,
  [L["Baroque Sword Scabbard"]]                = 64453,
  [L["Beautiful Preserved Fern"]]              = 63121,
  [L["Belt Buckle with Anvilmar Crest"]]       = 63113,
  [L["Black Trilobite"]]                       = 63109,
  [L["Blessing of the Old God"]]               = 64481,
  [L["Bodacious Door Knocker"]]                = 64339,
  [L["Bone Gaming Dice"]]                      = 63112,
  [L["Bones of Transformation"]]               = 64646,
  [L["Boot Heel with Scrollwork"]]             = 64340,
  [L["Bracelet of Jade and Coins"]]            = 64346,
  [L["Canopic Jar"]]                           = 64657,
  [L["Carcanet of the Hundred Magi"]]          = 64647,
  [L["Carved Harp of Exotic Wood"]]            = 64442,
  [L["Castle of Sand"]]                        = 64652,
  [L["Cat Statue with Emerald Eyes"]]          = 64653,
  [L["Ceramic Funeral Urn"]]                   = 63409,
  [L["Chalice of the Mountain Kings"]]         = 64373,
  [L["Chest of Tiny Glass Animals"]]           = 64379,
  [L["Cinnabar Bijou"]]                        = 63524,
  [L["Cloak Clasp with Antlers"]]              = 63407,
  [L["Clockwork Gnome"]]                       = 64372,
  [L["Coin from Eldre'Thalas"]]                = 63525,
  [L["Cracked Crystal Vial"]]                  = 64381,
  [L["Crawling Claw"]]                         = 60847,
  [L["Delicate Music Box"]]                    = 64357,
  [L["Dented Shield of Horuz Killcrow"]]       = 64362,
  [L["Devilsaur Tooth"]]                       = 64349,
  [L["Dignified Portrait"]]                    = 64455,
  [L["Drakkari Sacrificial Knife"]]            = 64375,
  [L["Druid and Priest Statue Set"]]           = 64361,
  [L["Dwarven Baby Socks"]]                    = 66054,
  [L["Eerie Smolderthorn Idol"]]               = 63523,
  [L["Engraved Scimitar Hilt"]]                = 64656,
  [L["Ewer of Jormungar Blood"]]               = 64479,
  [L["Extinct Turtle Shell"]]                  = 69764,
  [L["Fanged Cloak Pin"]]                      = 64464,
  [L["Feathered Gold Earring"]]                = 63413,
  [L["Feathered Raptor Arm"]]                  = 64385,
  [L["Fetish of Hir'eek"]]                     = 63120,
  [L["Fiendish Whip"]]                         = 64436,
  [L["Fierce Wolf Figurine"]]                  = 64421,
  [L["Fine Bloodscalp Dinnerware"]]            = 66058,
  [L["Fine Crystal Candelabra"]]               = 64454,
  [L["Flint Striker"]]                         = 64462,
  [L["Fossilized Hatchling"]]                  = 60955,
  [L["Fossilized Raptor"]]                     = 60954,
  [L["Gahz'rilla Figurine"]]                   = 64347,
  [L["Golden Chamber Pot"]]                    = 64342,
  [L["Gray Candle Stub"]]                      = 64418,
  [L["Green Dragon Ring"]]                     = 63528,
  [L["Gruesome Heart Box"]]                    = 64477,
  [L["Hairpin of Silver and Malachite"]]       = 64356,
  [L["Haunted War Drum"]]                      = 69777,
  [L["Headdress of the First Shaman"]]         = 64644,
  [L["Highborne Pyxis"]]                       = 63129,
  [L["Highborne Soul Mirror"]]                 = 64358,
  [L["Imprint of a Kraken Tentacle"]]          = 64473,
  [L["Infested Ruby Ring"]]                    = 64476,
  [L["Inlaid Ivory Comb"]]                     = 63130,
  [L["Insect in Amber"]]                       = 64350,
  [L["Intricate Treasure Chest Key"]]          = 64459,
  [L["Ironstar's Petrified Shield"]]           = 64344,
  [L["Jade Asp with Ruby Eyes"]]               = 63412,
  [L["Kaldorei Amphora"]]                      = 64354,
  [L["Kaldorei Wind Chimes"]]                  = 64383,
  [L["Lizard Foot Charm"]]                     = 63118,
  [L["Maul of Stone Guard Mur'og"]]            = 64417,
  [L["Mithril Chain of Angerforge"]]           = 64368,
  [L["Moltenfist's Jeweled Goblet"]]           = 63414,
  [L["Necklace with Elune Pendant"]]           = 66055,
  [L["Nifflevar Bearded Axe"]]                 = 64460,
  [L["Notched Sword of Tunadil the Redeemer"]] = 64337,
  [L["Pendant of the Scarab Storm"]]           = 64881,
  [L["Pewter Drinking Cup"]]                   = 63408,
  [L["Pipe of Franclorn Forgewright"]]         = 64659,
  [L["Plated Elekk Goad"]]                     = 64458,
  [L["Proto-Drake Skeleton"]]                  = 64468,
  [L["Pterrordax Hatchling"]]                  = 69821,
  [L["Puzzle Box of Yogg-Saron"]]              = 64482,
  [L["Queen Azshara's Dressing Gown"]]         = 64643,
  [L["Ring of the Boy Emperor"]]               = 64904,
  [L["Rusted Steak Knife"]]                    = 64419,
  [L["Scandalous Silk Nightgown"]]             = 63131,
  [L["Scepter of Azj'Aqir"]]                   = 64883,
  [L["Scepter of Bronzebeard"]]                = 64487,
  [L["Scepter of Charlga Razorflank"]]         = 64367,
  [L["Scepter of Nekros Skullcrusher"]]        = 64420,
  [L["Scepter of Nezar'Azret"]]                = 64475,
  [L["Scepter of Xavius"]]                     = 64382,
  [L["Scepter of the Nathrezim"]]              = 64444,
  [L["Scimitar of the Sirocco"]]               = 64885,
  [L["Scorched Staff of Shadow Priest Anund"]] = 64366,
  [L["Scramseax"]]                             = 64461,
  [L["Shard of Petrified Wood"]]               = 66056,
  [L["Shattered Glaive"]]                      = 63526,
  [L["Silver Kris of Korl"]]                   = 64483,
  [L["Silver Neck Torc"]]                      = 63411,
  [L["Silver Scroll Case"]]                    = 64648,
  [L["Six-Clawed Cornice"]]                    = 64478,
  [L["Sketch of a Desert Palace"]]             = 64658,
  [L["Skull Drinking Cup"]]                    = 64438,
  [L["Skull Staff of Shadowforge"]]            = 64371,
  [L["Skull-Shaped Planter"]]                  = 64345,
  [L["Soapstone Scarab Necklace"]]             = 64654,
  [L["Spidery Sundial"]]                       = 64474,
  [L["Spiked Gauntlets of Anvilrage"]]         = 64485,
  [L["Staff of Ammunae"]]                      = 64880,
  [L["Staff of Sorcerer-Thane Thaurissan"]]    = 64489,
  [L["Stone Gryphon"]]                         = 63410,
  [L["Strange Silver Paperweight"]]            = 64443,
  [L["Strange Velvet Worm"]]                   = 66057,
  [L["String of Small Pink Pearls"]]           = 64378,
  [L["The Innkeeper's Daughter"]]              = 64488,
  [L["The Last Relic of Argus"]]               = 64457,
  [L["Thorned Necklace"]]                      = 64467,
  [L["Tile of Glazed Clay"]]                   = 64437,
  [L["Tiny Bronze Scorpion"]]                  = 64389,
  [L["Tiny Oasis Mosaic"]]                     = 64655,
  [L["Tooth with Gold Filling"]]               = 64374,
  [L["Twisted Ammonite Shell"]]                = 63527,
  [L["Tyrande's Favorite Doll"]]               = 64645,
  [L["Umbra Crescent"]]                        = 64650,
  [L["Vicious Ancient Fish"]]                  = 64387,
  [L["Vizier's Scrawled Streamer"]]            = 64480,
  [L["Voodoo Figurine"]]                       = 69824,
  [L["Vrykul Drinking Horn"]]                  = 69775,
  [L["Warmaul of Burningeye"]]                 = 64484,
  [L["Winged Helm of Corehammer"]]             = 64343,
  [L["Wisp Amulet"]]                           = 64651,
  [L["Wooden Whistle"]]                        = 63111,
  [L["Word of Empress Zoe"]]                   = 64486,
  [L["Worn Hunting Knife"]]                    = 63110,
  [L["Zandalari Voodoo Doll"]]                 = 63115,
  [L["Zin'rokh, Destroyer of Worlds"]]         = 64377,
};

-------------------------------------------------------------------------------
--                L  O  C  A  L     F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to switch to the first page of completed artifacts when the 'Prev'
-- button is right-clicked.
--
local function NigglesArchaeologyFirst(self, button)
  -- Check the option is enabled and the right button was clicked
  if ((NigglesDBC.settings.UiFirstLastPage == true) and
      (button == "RightButton")) then
    -- Click the 'Prev' button until it is disabled
    while (ArchaeologyFrameCompletedPagePrevPageButton:IsEnabled()) do
      ArchaeologyFrame_PageClick(self, false);
     end
  end

  return;
end

--
-- Function to get info used by other functions
--
local function NigglesArchaeologyGetInfo()
  -- Local Variables
  local idx;
  local numRaces = GetNumArchaeologyRaces();
  local itemId;

  -- Get info about the races
  for idx = 1, numRaces do
    raceName[idx], _, itemId = GetArchaeologyRaceInfo(idx);
    raceKeystoneId[itemId] = idx;
    raceFragment[raceName[idx].." "..L["Archaeology Fragment"]] = true;
  end

  return;
end

--
-- Function to switch to the last page of completed artifacts when the 'Next'
-- button is right-clicked.
--
local function NigglesArchaeologyLast(self, button)
  -- Check the option is enabled and the right button was clicked
  if ((NigglesDBC.settings.UiFirstLastPage == true) and
      (button == "RightButton")) then
    -- Click the 'Next' button until it is disabled
    while (ArchaeologyFrameCompletedPageNextPageButton:IsEnabled()) do
      ArchaeologyFrame_PageClick(self, true);
    end
  end

  return;
end

-------------------------------------------------------------------------------
--                G  L  O  B  A  L    F  U  N  C  T  I  O  N  S
-------------------------------------------------------------------------------

--
-- Function to display the tooltip for an artifact
--
function NigglesArchaeologyTooltipDisplay(frame)
  -- Local Variables
  local name;

  -- Get the name of the selected artifact
  name = GetSelectedArtifactInfo();

  -- Check the ID of the artifact is known
  if (artifactId[name] ~= nil) then
    -- Display the tooltip for the artifact
    GameTooltip:SetOwner(frame, "ANCHOR_BOTTOMRIGHT", 0);
    GameTooltip:SetHyperlink("item:"..artifactId[name]..":0:0:0:0:0:0:0");
    GameTooltip:Show();
  end

  return;
end

--
-- Function to process a click on the tooltip for an artifact
--
function NigglesArchaeologyTooltipOnClick(frame)
  -- Local Variables
  local name;
  local hyperlink;

  -- Get the name of the selected artifact
  name = GetSelectedArtifactInfo();

  -- Check the ID of the artifact is known
  if (artifactId[name] ~= nil) then
    -- Get the artifact's hyperlink
    _, hyperlink = GetItemInfo(artifactId[name])
    if (hyperlink ~= nil) then
      -- Call the standard handler
      HandleModifiedItemClick(hyperlink);
    end
  end

  return;
end

--
-- Function to update the progress of each race's artifact
--
function NigglesArchaeologySummaryUpdate()
  -- Local Variables
  local numRaces = GetNumArchaeologyRaces();
  local button;
  local idx;
  local name;
  local numFragments;
  local numRequired;
  local numSlots;
  local bagIdx;
  local raceKeystones = {};
  local itemId;
  local itemCount;
  local numSockets;

  -- Check if the archaeology panels should be enhanced
  if ((NigglesDBC.settings.ProfArchHilite == true) or
      (NigglesDBC.settings.ProfArchKeystones == true)) then
    -- Get info for acrhaeologu, if required
    if (next(raceName) == nil) then
      NigglesArchaeologyGetInfo();
    end

    -- Search the player's bags for race keystones, if required
    if (NigglesDBC.settings.ProfArchKeystones == true) then
      for bagIdx = 0, NUM_BAG_SLOTS do
        numSlots = GetContainerNumSlots(bagIdx);
        for slotIdx = 1, numSlots do
          itemId = GetContainerItemID(bagIdx, slotIdx);
          if (raceKeystoneId[itemId] ~= nil) then
            _, itemCount = GetContainerItemInfo(bagIdx, slotIdx);
            raceKeystones[raceKeystoneId[itemId]] =
              (raceKeystones[raceKeystoneId[itemId]] or 0)+itemCount;
          end
        end
      end
    end

    -- Update the progress of each race's artifact
    for idx = 1, numRaces do
      button = _G["ArchaeologyFrameSummaryPageRace"..idx];
      if (button ~= nil) then
        -- Check if the player has started any artifacts for the race
        if (GetNumArtifactsByRace(idx) > 0) then
          -- Select the race's artifact
          SetSelectedArtifact(idx);

          -- Get the number of fragments currently possessed and required
          _, _, _, numFragments, numRequired = GetArchaeologyRaceInfo(idx);

          -- Update the number of fragments, if required
          if (NigglesDBC.settings.ProfArchKeystones == true) then
            -- Get the number of sockets the current artifact has
            _, _, _, _, _, numSockets =  GetSelectedArtifactInfo();

            -- Update the number of fragments
            numFragments = numFragments+
              (math.min(numSockets, (raceKeystones[idx] or 0))*12);
          end

          -- Update the progress
          if ((NigglesDBC.settings.ProfArchHilite == true) and
              (numFragments >= numRequired)) then
            button.raceName:SetText(raceName[idx].."|n"..
              NORMAL_FONT_COLOR_CODE..
              numFragments.."/"..numRequired..
              FONT_COLOR_CODE_CLOSE);
          else
            button.raceName:SetText(raceName[idx].."|n"..
              numFragments.."/"..numRequired);
          end
        end
      end
    end
  end

  return;
end

--
-- Function to hook into the Archaeology panel
--
function NigglesArchaeologyHookPanel()
  -- Add a hook to the function used to update the 'Summary' page
  hooksecurefunc("ArchaeologyFrame_UpdateSummary",
    NigglesArchaeologySummaryUpdate);
  ArchaeologyFrame.summaryPage.UpdateFrame =
    ArchaeologyFrame_UpdateSummary;

  -- Hook functions into the 'Prev' and 'Next' buttons in the 'Completed' page
  ArchaeologyFrameCompletedPagePrevPageButton:HookScript("OnMouseUp",
    NigglesArchaeologyFirst);
  ArchaeologyFrameCompletedPageNextPageButton:HookScript("OnMouseUp",
    NigglesArchaeologyLast);

  -- Create the frame used to provide a tooltip for the current artifact
  CreateFrame("Frame", "NigglesArtifactIcon",
    ArchaeologyFrameArtifactPage, "NigglesArtifactIconTemplate");
  if (NigglesDBC.settings.ProfArchEnhIcon == true) then
    NigglesArtifactIcon:Show();
  else
    NigglesArtifactIcon:Hide();
  end

  -- Enable right clicking on the artifact page to go back to the summary page
  ArchaeologyFrameArtifactPage:EnableMouse(true);
  ArchaeologyFrameArtifactPage:HookScript("OnMouseUp",
    function(self, button)
      -- Check the option is enabled and the right button was clicked
      if ((NigglesDBC.settings.ProfArchRClickBack == true) and
          (button == "RightButton")) then
        -- Click the 'Summary' button
        ArchaeologyFrame_OnTabClick(ArchaeologyFrameSummarytButton);
      end
    end);

  return;
end

--
-- Function to check if an item is an archaeology keystone
--
function NigglesArchaeologyIsFragment(itemName)
  -- Get info for acrhaeologu, if required
  if (next(raceName) == nil) then
    NigglesArchaeologyGetInfo();
  end

  -- Check if the item's name matches an archaeology fragment
  return (raceFragment[itemName] == true);
end

--
-- Function to check if an item is an archaeology keystone
--
function NigglesArchaeologyIsKeystone(itemLink)
  -- Extract the item ID from the item link
  local itemId = string.gsub(itemLink, "^[^:]*:([^:]*):.*$", "%1");

  -- Get info for acrhaeologu, if required
  if (next(raceName) == nil) then
    NigglesArchaeologyGetInfo();
  end

  -- Check if the item ID is for an archaeology keystone
  return (raceKeystoneId[tonumber(itemId)] ~= nil);
end
